package kodused_oad;

import java.io.Serializable;
import java.sql.*;
import java.util.ArrayList;

import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import java.io.*;

import org.w3c.dom.*;

public class BaasiUba implements Serializable{

	Connection c;
	Statement s;


	public BaasiUba(){
		try{
		// Step 1. Load the JDBC driver
		Class.forName("com.mysql.jdbc.Driver");
		// Step 2. Create a Connection object
		c=DriverManager.getConnection("jdbc:mysql://localhost/kirjasobrad?user=root&password=juku");
		System.out.println("Got connection");
		s = c.createStatement();

		}catch (Exception e) {

			System.out.println(e.toString());
    	}

	}

	public int getKasutajateArv(){
		int arv=0;
		try{
			String sql = "select count(id) as arv from kasutajad;";
			ResultSet rs = s.executeQuery(sql);
			rs.next();
			arv=rs.getInt("arv");
			rs.close();
			return arv;
		} catch(Exception e){
			System.out.println("Viga kasutajate arvu kysimisel: "+e.toString());
			return arv;
		}
	}

	public ArrayList getKoikKasutajad() throws Exception{

		String sql = "select * from kasutajad";
		ResultSet rs = s.executeQuery(sql);
		ArrayList nimed=new ArrayList();


		while(rs.next()){

			KasutajaAndmeteTyyp blah=new KasutajaAndmeteTyyp();
			blah.id=rs.getInt("id");
			blah.nimi=rs.getString("nimi");
			blah.vanus=rs.getInt("vanus");
//			blah.sugu=rs.getString("sugu");

			nimed.add(blah);


		}

		rs.close();
		return nimed;

	}

	public KasutajaAndmeteTyyp getKasutajaAndmed(int kasutaja_id) throws Exception{
		ResultSet rs;
		String sql = "select * from kasutajad where id="+kasutaja_id+";";
		KasutajaAndmeteTyyp kasutaja=new KasutajaAndmeteTyyp();
		rs = s.executeQuery(sql);
		rs.next();
		kasutaja.id=rs.getInt("id");
		kasutaja.nimi=rs.getString("nimi");
		kasutaja.vanus=rs.getInt("vanus");
		kasutaja.sugu=rs.getString("sugu");
		rs.close();
		ArrayList kasutaja_huvid=new ArrayList();
		sql = "select kasutaja_huviala.id as kh_id, kasutaja_id, huviala_id, nimetus from kasutaja_huviala, huvialad where kasutaja_id="+kasutaja_id+" and huvialad.id=huviala_id;";
		rs = s.executeQuery(sql);
		while(rs.next()){
			HuvialaAndmeteTyyp huviala=new HuvialaAndmeteTyyp();
			huviala.id=rs.getInt("huviala_id");
			huviala.nimetus=rs.getString("nimetus");
			kasutaja_huvid.add(huviala);
		}
		kasutaja.huvid=kasutaja_huvid;

		return kasutaja;
	}

	public void salvestaUusKasutaja(String nimi, String sugu, int vanus) throws Exception{
		String sql="insert into kasutajad values('','"+nimi+"',"+vanus+",'"+sugu+"');";
		s.executeUpdate(sql);
	}

	public ArrayList getHuvialad() throws Exception{

		String sql = "select * from huvialad";
		ResultSet rs = s.executeQuery(sql);
		ArrayList huvid=new ArrayList();

		while(rs.next()){

			HuvialaAndmeteTyyp blah=new HuvialaAndmeteTyyp();
			blah.id=rs.getInt("id");
			blah.nimetus=rs.getString("nimetus");
			huvid.add(blah);
		}

		rs.close();
		return huvid;

	}

	public void salvestaKasutajaleHuviala(int kasutaja_id, int huviala_id) throws Exception{
		String sql="insert into kasutaja_huviala values('',"+kasutaja_id+","+huviala_id+");";
		s.executeUpdate(sql);
	}
	
	public void eemaldaKasutajaltHuviala(int kasutaja_id, int huviala_id) throws Exception{
		String sql="delete from kasutaja_huviala where kasutaja_id="+kasutaja_id+" and huviala_id="+huviala_id+"";
		s.executeUpdate(sql);
	}

	public void salvestaUusHuviala(String nimetus) throws Exception{
		String sql="insert into huvialad values('','"+nimetus+"');";
		s.executeUpdate(sql);
	}

	public void genereeriXMLv2ljund() throws Exception{
		Document d=DocumentBuilderFactory.newInstance().newDocumentBuilder().newDocument();
		Element juur=d.createElement("kirjasobrad");
  		d.appendChild(juur);
		
		ArrayList kasutajad=getKoikKasutajad();
		for(int i=0; i<kasutajad.size(); i++){
			KasutajaAndmeteTyyp blah=(KasutajaAndmeteTyyp)kasutajad.get(i);
			KasutajaAndmeteTyyp kasutajainfo=getKasutajaAndmed(blah.id);

			Element sober=d.createElement("sober");
			juur.appendChild(sober);
			Element e;

			e=d.createElement("id");
			e.appendChild(d.createTextNode(kasutajainfo.id+""));
			sober.appendChild(e);
			
			e=d.createElement("nimi");
			e.appendChild(d.createTextNode(kasutajainfo.nimi));
			sober.appendChild(e);

			e=d.createElement("vanus");
			e.appendChild(d.createTextNode(kasutajainfo.vanus+""));
			sober.appendChild(e);

			e=d.createElement("sugu");
			e.appendChild(d.createTextNode(kasutajainfo.sugu));
			sober.appendChild(e);

			e=d.createElement("huvid");
			ArrayList k_huvid=kasutajainfo.huvid;
			for(int j=0; j<k_huvid.size();j++){
				HuvialaAndmeteTyyp k_huvi=(HuvialaAndmeteTyyp)k_huvid.get(j);
				Element huvi=d.createElement("huvi");
				huvi.appendChild(d.createTextNode(k_huvi.nimetus));
				e.appendChild(huvi);
			}
			sober.appendChild(e);
		}

    	Transformer t=TransformerFactory.newInstance().newTransformer();
    	FileOutputStream valja=new FileOutputStream("webapps/ROOT/kodune/kirjasobrad.xml");
    	t.transform(new DOMSource(d), new StreamResult(valja));
    	valja.close();

	}
	
	public void tekitaTekstiFailid() throws Exception{
		ArrayList kasutajateNimekiri=getKoikKasutajad();
		PrintWriter kasutajateNimekirjaFail=new PrintWriter(new FileWriter("webapps/ROOT/kodune/txt/kasutajad.txt",false));
		for(int i=0;i<kasutajateNimekiri.size();i++){
			KasutajaAndmeteTyyp kasutaja=(KasutajaAndmeteTyyp)kasutajateNimekiri.get(i);
			kasutajateNimekirjaFail.println(kasutaja.nimi);
			KasutajaAndmeteTyyp kasutajaInfo=getKasutajaAndmed(kasutaja.id);
			PrintWriter kasutajaFail=new PrintWriter(new FileWriter("webapps/ROOT/kodune/txt/"+kasutajaInfo.nimi+".txt"));
			kasutajaFail.println(kasutajaInfo.nimi+" ("+kasutajaInfo.vanus+") "+kasutajaInfo.sugu);
			ArrayList huvideList=kasutajaInfo.huvid;
			for(int j=0; j<huvideList.size(); j++){
				HuvialaAndmeteTyyp huvi=(HuvialaAndmeteTyyp)huvideList.get(j);
				kasutajaFail.println(" - "+huvi.nimetus);
			}
			kasutajaFail.close();
		}
		kasutajateNimekirjaFail.close();
	}

	protected void finalize() throws Exception{
		s.close();
      	c.close();
	}
}
